Index: rtp.c
===================================================================
RCS file: /usr/cvsroot/asterisk/rtp.c,v
retrieving revision 1.154
diff -u -r1.154 rtp.c
--- rtp.c	11 Nov 2005 04:07:03 -0000	1.154
+++ rtp.c	15 Nov 2005 10:40:19 -0000
@@ -1125,6 +1125,8 @@
 		digit = digit - 'A' + 12;
 	else if ((digit >= 'a') && (digit <= 'd')) 
 		digit = digit - 'a' + 12;
+	else if (digit == 'X')
+		digit = 16;
 	else {
 		ast_log(LOG_WARNING, "Don't know how to represent '%c'\n", digit);
 		return -1;
Index: channels/chan_sip.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_sip.c,v
retrieving revision 1.909
diff -u -r1.909 chan_sip.c
--- channels/chan_sip.c	12 Nov 2005 02:57:43 -0000	1.909
+++ channels/chan_sip.c	15 Nov 2005 10:40:28 -0000
@@ -8594,8 +8594,7 @@
 	
 		if (p->owner) {	/* PBX call */
 			if (!ast_strlen_zero(buf)) {
-				if (sipdebug)
-					ast_verbose("* DTMF received: '%c'\n", buf[0]);
+				/* Some devices send DTMF *#ABCD! as the char, some as two digits "10" - "15" */  
 				if (buf[0] == '*')
 					event = 10;
 				else if (buf[0] == '#')
@@ -8612,15 +8611,27 @@
 					resp = '#';
 				} else if (event < 16) {
 					resp = 'A' + (event - 12);
+				} else if (event < 17) {
+					resp = 'X';
+				} else 
+					resp = '?';
+				if (sipdebug)
+					ast_verbose("* DTMF received: '%s' '%c'\n", buf, resp);
+				if (resp != '?') { /* ignore invalid events */
+					/* Build DTMF frame and deliver to PBX for transmission to other call leg*/
+					memset(&f, 0, sizeof(f));
+					if (resp == 'X') {
+  						f.frametype = AST_FRAME_CONTROL;
+  						f.subclass = AST_CONTROL_FLASH;
+					} else {
+  						f.frametype = AST_FRAME_DTMF;
+  						f.subclass = resp;
+					}
+					f.offset = 0;
+					f.data = NULL;
+					f.datalen = 0;
+					ast_queue_frame(p->owner, &f);
 				}
-				/* Build DTMF frame and deliver to PBX for transmission to other call leg*/
-				memset(&f, 0, sizeof(f));
-				f.frametype = AST_FRAME_DTMF;
-				f.subclass = resp;
-				f.offset = 0;
-				f.data = NULL;
-				f.datalen = 0;
-				ast_queue_frame(p->owner, &f);
 			}
 			transmit_response(p, "200 OK", req);
 			return;
